PD = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
local frame, damag, skill, typed
local a, cd, cs, ct, da, dn, dt, f, x, y, p1, p2, h, v, t
if GetAddOnInfo("LibSharedMedia-2.0") then EnableAddOn("LibSharedMedia-2.0") LoadAddOn("LibSharedMedia-2.0") end
local SharedMedia = LibStub and LibStub:GetLibrary("LibSharedMedia-2.0", true)
local L = setmetatable({}, { __index = function(self, key) rawset(self, key, key) return key end }) PD.L = L

function PD:OnInitialize()
	self:RegisterDB("pddb", "pdChardb")
	self:RegisterDefaults('profile', {
		alignH = "CENTER",
		alignV = "TOP",
		colorDamag = { r = 255/255, g = 255/255, b = 255/255, },
		colorTyped = { r = 255/255, g = 255/255, b = 255/255, },
		colorSkill = { r = 255/255, g = 255/255, b = 255/255, },
		fontFace = "Friz Quadrata TT",
		fontSizeDamag = 32,
		fontSizeTyped = 16,
		fontSizeSkill = 12,
		pos = "CENTER",
		posX = 0, 
		posY = 0
	})
	self:RegisterDefaults('char', {
		damtype = "7",
		skill = "3"
	})
	self:LoadOptions()
end

function PD:UpdateText()
	if self.db.char.damtype == "1" then dn = "Physical Power" dt = GetSpellBonusDamage(1)
	elseif self.db.char.damtype == "2" then dn = "Holy Damage" dt = GetSpellBonusDamage(2)
	elseif self.db.char.damtype == "3" then dn = "Fire Damage" dt = GetSpellBonusDamage(3)
	elseif self.db.char.damtype == "4" then dn = "Nature Damage" dt = GetSpellBonusDamage(4)
	elseif self.db.char.damtype == "5" then dn = "Frost Damage" dt = GetSpellBonusDamage(5)
	elseif self.db.char.damtype == "6" then dn = "Shadow Damage" dt = GetSpellBonusDamage(6)
	elseif self.db.char.damtype == "7" then dn = "Arcane Damage" dt = GetSpellBonusDamage(7)
	elseif self.db.char.damtype == "8" then dn = "Healing Power" dt = GetSpellBonusHealing()
	elseif self.db.char.damtype == "9" then dn = "Attack Power" local base, posBuff, negBuff = UnitAttackPower("player") dt = base + posBuff + negBuff
	elseif self.db.char.damtype == "10" then dn = "Ranged AP" local base, posBuff, negBuff = UnitRangedAttackPower("player") dt = base + posBuff + negBuff
	else dn = "Number of the Beast" dt = 666
	end

	if self.db.char.skill == "0" then dk = ""
	elseif self.db.char.skill == "1" then local _,total,_,_ = UnitResistance("player",0) dk = total.." armor"
	elseif self.db.char.skill == "2" then local _,total,_,_ = UnitResistance("player",1) dk = total.." Holy resistance"
	elseif self.db.char.skill == "3" then local _,total,_,_ = UnitResistance("player",2) dk = total.." Fire resistance"
	elseif self.db.char.skill == "4" then local _,total,_,_ = UnitResistance("player",3) dk = total.." Nature resistance"
	elseif self.db.char.skill == "5" then local _,total,_,_ = UnitResistance("player",4) dk = total.." Frost resistance"
	elseif self.db.char.skill == "6" then local _,total,_,_ = UnitResistance("player",5) dk = total.." Shadow resistance"
	elseif self.db.char.skill == "7" then local _,total,_,_ = UnitResistance("player",6) dk = total.." Arcane resistance"
	end
	
	damag:SetText( dt )
	typed:SetText( dn )
	skill:SetText( dk )
end

function PD:UpdateScheduledEvents()
	self:CancelAllScheduledEvents()
	self:ScheduleRepeatingEvent(self.UpdateText, 0.2, self)
	self:UpdateText()
end

function PD:UpdateColors()
	cd = self.db.profile.colorDamag
	damag:SetTextColor(cd.r, cd.g, cd.b)
	cd = self.db.profile.colorTyped
	typed:SetTextColor(cd.r, cd.g, cd.b)
	cd = self.db.profile.colorSkill
	skill:SetTextColor(cd.r, cd.g, cd.b)
end

function PD:UpdatePosition()
	a = self.db.profile.pos
	x = a:find("RIGHT") and -self.db.profile.posX or self.db.profile.posX
	y = a:find("TOP") and -self.db.profile.posY or self.db.profile.posY
	h = self.db.profile.align or "CENTER"

	frame:ClearAllPoints()
	frame:SetPoint(a, UIParent, a, x, y)

	if h == "LEFT" then p1 = "TOPLEFT"
	elseif h == "RIGHT" then p1 = "TOPRIGHT"
	else p1 = "TOP"
	end
	
	damag:SetPoint(p1, frame, p1, 0, 0)
	damag:SetJustifyH(h)
	typed:SetPoint(p1, damag, p1, 0, -self.db.profile.fontSizeDamag)
	typed:SetJustifyH(h)
	skill:SetPoint(p1, typed, p1, 0, -self.db.profile.fontSizeDamag+self.db.profile.fontSizeTyped)
	skill:SetJustifyH(h)
end

function PD:UpdateFonts()
	t = SharedMedia and SharedMedia:Fetch("font", self.db.profile.fontFace) or "Fonts\\FRIZQT__.ttf" 
	damag:SetFont(t, self.db.profile.fontSizeDamag, self.db.profile.fontOutline)
	typed:SetFont(t, self.db.profile.fontSizeTyped, self.db.profile.fontOutline)
	skill:SetFont(t, self.db.profile.fontSizeSkill, self.db.profile.fontOutline)

	if self.db.profile.fontShadow then
		damag:SetShadowOffset(1, -1)
		typed:SetShadowOffset(1, -1)
		skill:SetShadowOffset(1, -1)
	else
		damag:SetShadowOffset(0, 0)
		typed:SetShadowOffset(0, 0)
		skill:SetShadowOffset(0, 0)
	end

	damag:SetText("1234")
	typed:SetText("Shadow Damage")
	skill:SetText("667 Shadow resistance")
	frame:SetWidth(typed:GetWidth() > damag:GetWidth() and typed:GetWidth() or damag:GetWidth() or skill:GetWitch())
	frame:SetHeight(damag:GetHeight() + typed:GetHeight() + skill:GetHeight())
end

function PD:OnEnable()
	if not PD_Frame then
		frame = CreateFrame("Frame", "PD_Frame", UIParent)
		frame:SetFrameStrata("BACKGROUND")
		frame:SetFrameLevel(0)
	
		damag = frame:CreateFontString("PD_Damag", "OVERLAY")
		typed = frame:CreateFontString("PD_Typed", "OVERLAY")
		skill = frame:CreateFontString("PD_Skill", "OVERLAY")
	
		self:UpdateFonts()
		self:UpdateColors()
		self:UpdatePosition()
	
		frame:Show()
	end
	self:UpdateScheduledEvents()
end

function PD:OnDisable()
	PD_Damag:SetText()
	PD_Typed:SetText()
	PD_Skill:SetText()
	PD_Frame:Hide()
end